﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'NOTA IMPORTANTE  PER MODIFICARE I COLORI DELLA TOPBAR
' OCCORRE MODIFICARE IL FILE COLORS.
' CHE SI TROVA NELLE VARIE SOTTOCARTELLE DELLA VERSIONE DELL'SDK MetaSB\resources\values-v28



Sub Class_Globals
	
	Private mParentActivity As Activity
	Private mParentObject As Object
	
	' new objects
	Private VP 					As AHViewPager
	Private PC 					As AHPageContainer
	Private TabLayout 	As DSTabLayout
	Private ToolBar 		As ACToolBarLight
	Private ABHelper 		As ACActionBar
	
	Private mCheckEnableUser As Boolean = True
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aParent As Object, aActivity As Activity, aWidhtTabs As Boolean)
	
	mParentObject		=	aParent
	mParentActivity	=	aActivity

	ABHelper.Initialize
	PC.Initialize
	
	TabLayout.Initialize("TabLayout")
	TabLayout.TabMode = TabLayout.MODE_SCROLLABLE
	
	CreateToolBar	
	
	If aWidhtTabs Then
		CreateTabs
		Complete	
	End If
	
		
	If SubExists(mParentObject, "Create_Interface") Then
		CallSub(mParentObject, "Create_Interface")
	Else
		'Log("Non trovata interfaccia utente")
	End If
	
	' 05/07/17 - evito di dover mettere il titolo su tutte le finestre
	mParentActivity.Title 			= "Test"
	
	
	'uso il tag della activity per passare il parametro
	If aActivity.Tag <> Null Then
		mCheckEnableUser = aActivity.Tag
	End If
	
	

	
End Sub

' creo la toolbar
private Sub CreateToolBar
	
	ToolBar.Initialize("ToolBar")
	
	mParentActivity.AddView(ToolBar, 0,0,100%x, 40dip)
	
	ToolBar.Elevation 			= 5dip
	ToolBar.PopupTheme 			=  ToolBar.THEME_LIGHT
	ToolBar.TitleTextColor		= GUI.GetColorFromEsacedimal("#FFFFFF")'GUI.GetColorFromEsacedimal("#525252")
	ToolBar.SubTitleTextColor	= GUI.GetColorFromEsacedimal("#FFFFFF") 'GUI.GetColorFromEsacedimal("#525252") ' 04/07/17 preferisco uniformare Colors.White
	
	
	ToolBar.SetAsActionBar  
	
'	Dim ac As AppCompat
	ToolBar.Color	=	GUI.GetPrimaryColorApp 'ac.GetThemeAttribute("colorPrimary")
		
	If GUI.GetOrientation = 1 Then
		ToolBar.Height = 48dip
	Else
		ToolBar.Height = 56dip
	End If

	
	If GUI.GetDevicePhysicalSize > 6.5 Then
		ToolBar.Height = 64dip
	End If
	
	' necessario per far funzionare  Toolbar_NavigationItemClick  anche senza menu, diversamente non funziona senza menu
	' senza questa chiamata, viene chiamata la funzione Activity_ActionBarHomeClick della activity solo se c'è un menu
	ToolBar.InitMenuListener
	
	

End Sub

' ricrea la toolbar 
Public Sub Invalidate
	CreateToolBar
End Sub

Public Sub getToolbarObject As ACActionBar
	Return ABHelper
End Sub


public Sub getActivity As Activity
	Return mParentActivity
End Sub

' altezza della sola toolbar. Se gestisci le tabbed devi usare HeightHeader
public Sub getToolBarHeight As Int
	Return ToolBar.Height
End Sub

' restituisce l'altezza occupata dalla toolbar e dal layout
public Sub getHeightHeader As Int
	Return ToolBar.Height + TabLayout.Height
End Sub

' imposta il titolo della toolbar
Public Sub setTitleToolbar(aTitle As String)
	ToolBar.Title = aTitle
End Sub

'imposta il sottotitolo della toolbar
Public Sub setSubTitleToolbar(aSubTitle As String)
	ToolBar.SubTitle = aSubTitle
End Sub

'
public Sub setLogoToolbar(aBitMap As Bitmap)
	ToolBar.LogoBitmap				= aBitMap' LoadBitmap(File.DirAssets, "img/meta_piccolo.png")	
	'ToolBar.LogoDrawable			= aBitMap
End Sub

public Sub setBitMapNavigationToolBar(aBitMap As Bitmap)
	ToolBar.NavigationIconBitmap	= aBitMap
End Sub

' rimuove bitmap di navigazione (freccia\logo)
public Sub RemoveNavigationBitMap
	ToolBar.NavigationIconBitmap	= Null
'	ABHelper.ShowUpIndicator = False ' necessario per rimuovere lo spazio del logo, che è stato impostato sopra
	
End Sub

' area tabs
private Sub CreateTabs
	
	mParentActivity.AddView(TabLayout, 0, ToolBar.Height, 100%x, 48dip)
	
	VP.Initialize("VP")
	
	mParentActivity.AddView(VP, 0,ToolBar.Height + TabLayout.Height, 100%x - 1dip, 100%y)
	
End Sub

Public Sub AddPage(View As View, Title As String, addToMenu As Boolean)

	PC.AddPage(View, Title)

	
	If addToMenu Then
		mParentActivity.AddMenuItem(Title, "Menu")
	End If
	
	
End Sub




public Sub GetPage(aPosition As Int) As View
	Return PC.GetPageObject(aPosition)
End Sub

Public Sub GetPageCount As Int
	Return PC.Count
End Sub

' permette di impostare il controllo della validiata utente, quindi impedire di aprire la activity
Public Sub setCheckEnableUser(aCheck As Boolean)
	mCheckEnableUser = aCheck
End Sub


Public Sub Complete
	
	'Set the PageContainer for the ViewPager
	VP.PageContainer = PC
	
	'Set colors. The indicator color defaults to "colorAccent"
	'Dim ac As AppCompat
	TabLayout.Color = 	GUI.GetPrimaryColorApp 'ac.GetThemeAttribute("colorPrimary")
	ToolBar.Color		=		GUI.GetPrimaryColorApp 'ac.GetThemeAttribute("colorPrimary")
	
	'Connect the TabLayout with the Viewpager. This will keep tabs and pages
	'in sync and creates a nice indicator animation.
	TabLayout.SetViewPager(VP)
	

End Sub

' viene chiamata dal sistema quando non ci sono menu. viene attivata dalla funzione ToolBar.InitMenuListener
Sub Toolbar_NavigationItemClick
	
	If SubExists(mParentObject, "Activity_ActionBarHomeClick") Then
		CallSub(mParentObject, 		"Activity_ActionBarHomeClick")
	Else
		CloseActivity
	End If
	
End Sub


public Sub CloseActivity
'	Log("CloseActivity::CUserInterface")

	mParentActivity.Finish
End Sub

#Region impostazione del VP

Public Sub SetTabPosition(aPos As Int)
	VP.GotoPage(aPos, True)
End Sub

public Sub SetTabPositionByName(aTabbedName As String)
	SetTabPosition(GetTabPosition(aTabbedName))
End Sub

Public Sub GetTabPosition(aTabName As String) As Int
	
	For i = 0 To PC.Count - 1
		
		Dim aName As String	=	PC.GetTitle(i)
		
		If aName = aTabName Then
			Return i
		End If
		
	Next
	
	Return -1
	
End Sub

' restituisce il nome della tabbed dalla posizione
public Sub GetTabNameByPosition(aPos As Int) As String
	
	If aPos >= 0 And aPos <= PC.Count Then
		Return PC.GetTitle(aPos)
	End If
	
End Sub



Public Sub setEnableVPSCrolling(aEnable As Boolean)
	VP.PagingEnabled = aEnable
End Sub


Sub VP_PageChanged (Position As Int)
'	Log("PageChanged: " & Position)	

		
	' passo alla classe parent il messaggio che può servire per fare operazioni particolari: bloccare lo scrolling orizzontale	
	If SubExists(mParentObject, "Page_Scrolled") Then
		CallSub2(mParentObject, "Page_Scrolled", Position)
	End If 
	
End Sub

Sub VP_PageCreated (Position As Int, Page As Object)
	' Log("PageCreated: " & Position)
End Sub

Sub VP_PageDestroyed (Position As Int, Page As Object)
	' Log("PageDestroyed: " & Position)
	
End Sub

Sub VP_PageScrolled (Position As Int, PositionOffset As Float, PositionOffsetPixels As Int)
	' Log("PageScrolled: " & Position & " Offset: " & PositionOffset & " OffsetPixels: " & PositionOffsetPixels) 
End Sub

Sub VP_PageScrollStateChanged (State As Int)
	'Log("StateChange: " & State)
End Sub

#End Region